using System;
using System.Drawing;
using System.Collections;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Grouping;
using System.Diagnostics;

namespace GGC_4tables
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
        private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;
        private GridRelationDescriptor _tmpDescr = null;
        private int _tabIndex = 0;
        private ImageList imageList1;
        private Button button1;
        private IContainer components;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

        public enum TableDefinition
        {
            One,
            Two,
            Three,
            Four
        }

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(Form1));
            this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
            this.imageList1 = new System.Windows.Forms.ImageList(this.components);
            this.button1 = new System.Windows.Forms.Button();
            ((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
            this.SuspendLayout();
            // 
            // gridGroupingControl1
            // 
            this.gridGroupingControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                        | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
            this.gridGroupingControl1.Location = new System.Drawing.Point(12, 37);
            this.gridGroupingControl1.Name = "gridGroupingControl1";
            this.gridGroupingControl1.Size = new System.Drawing.Size(339, 327);
            this.gridGroupingControl1.TabIndex = 0;
            this.gridGroupingControl1.Text = "gridGroupingControl1";
            this.gridGroupingControl1.VersionInfo = "3.301.0.0";
            // 
            // imageList1
            // 
            this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
            this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
            this.imageList1.Images.SetKeyName(0, "open.ico");
            // 
            // button1
            // 
            this.button1.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.button1.Location = new System.Drawing.Point(276, 12);
            this.button1.Name = "button1";
            this.button1.Size = new System.Drawing.Size(75, 23);
            this.button1.TabIndex = 1;
            this.button1.Text = "Add Column";
            this.button1.UseVisualStyleBackColor = true;
            this.button1.Click += new System.EventHandler(this.button1_Click);
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(363, 378);
            this.Controls.Add(this.button1);
            this.Controls.Add(this.gridGroupingControl1);
            this.Name = "Form1";
            this.Text = "Form1";
            this.Load += new System.EventHandler(this.Form1_Load);
            ((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
            this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}



        private void InitializeGrid()
        {
            gridGroupingControl1.Engine.UseOldUniformChildListRelation = true;
            GridTableDescriptor parentTD = gridGroupingControl1.TableDescriptor;
            gridGroupingControl1.TableControlQueryAllowDragColumn += new GridQueryAllowDragColumnEventHandler(gridGroupingControl1_TableControlQueryAllowDragColumn);

            foreach (int eIndex in Enum.GetValues(typeof(TableDefinition)))
            {
                TableDefinition actDef = (TableDefinition)eIndex;

                GridTableDescriptor childTD = gridGroupingControl1.GetTableDescriptor(actDef.ToString());
                GridTableCellStyleInfo nameStyle = childTD.Columns["A"].Appearance.AnyRecordFieldCell;
                nameStyle.ImageList = imageList1;


                gridGroupingControl1.GetTable(actDef.ToString()).TableOptions.AllowSortColumns = false;
                gridGroupingControl1.GetTable(actDef.ToString()).TableOptions.AllowDragColumns = true;

                // Autosize columns - This doesn't really work, because the first table ("One") doesn't
                // display any content after this call.
                GridTableModel model = gridGroupingControl1.GetTableModel(actDef.ToString());
                model.ColWidths.ResizeToFit(GridRangeInfo.Table(), GridResizeToFitOptions.IncludeHeaders | GridResizeToFitOptions.IncludeCellsWithinCoveredRange);
            }

            gridGroupingControl1.QueryCellStyleInfo += new GridTableCellStyleInfoEventHandler(OnQueryCellStyleInfo);
        }

        void gridGroupingControl1_TableControlQueryAllowDragColumn(object sender, GridQueryAllowDragColumnEventArgs e)
        {
            if (e.Reason == GridQueryAllowDragColumnReason.MouseUp)
            {
                string actDescriptorName = e.TableControl.TableDescriptor.Name;

                // Iterate thru each table
                foreach (int eIndex in Enum.GetValues(typeof(TableDefinition)))
                {
                    if (eIndex == 0)
                    {
                        Debug.WriteLine("\n");
                        TableDefinition actDef = (TableDefinition)eIndex;
                        GridTableDescriptor childTD = gridGroupingControl1.GetTableDescriptor(actDef.ToString());
                        string before = e.InsertBeforeColumn;
                        //string after = e.Column;
                        Debug.WriteLine("Before: " + before + ", " + childTD.NameToField(e.InsertBeforeColumn));
                        //Debug.WriteLine("After: " + after);
                        int toField = childTD.NameToField(e.InsertBeforeColumn);
                        int fromField = childTD.NameToField(e.Column);
                        if (toField != -1 && fromField != -1)
                        {
                            childTD.VisibleColumns.Move(fromField, toField);
                        }
                    }
                    e.AllowDrag = false;
                }
            }
        }

		private void Form1_Load(object sender, System.EventArgs e)
		{
			DataTable dt1 = new DataTable("One");
			dt1.Columns.Add(new DataColumn("A"));
			dt1.Columns.Add(new DataColumn("B"));
            dt1.Columns.Add(new DataColumn("C"));
            dt1.Columns.Add(new DataColumn("D"));
            for (int i = 0; i <= 12; i++)
            {
                DataRow newRow = dt1.NewRow();
                newRow["A"] = "This is a test";
                newRow["B"] = "Sample #n";
                newRow["C"] = "This is just one more test";
                newRow["D"] = "Nice";
                dt1.Rows.Add(newRow);
            }
			DataTable dt2 = new DataTable("Two");
			dt2.Columns.Add(new DataColumn("A"));
			dt2.Columns.Add(new DataColumn("B"));
			dt2.Columns.Add(new DataColumn("C"));
            dt2.Columns.Add(new DataColumn("D"));
            for (int i = 0; i <= 8; i++)
            {
                DataRow newRow = dt2.NewRow();
                newRow["A"] = "Test example #p";
                newRow["B"] = "Test";
                newRow["C"] = "Nice grid";
                newRow["D"] = "Again";
                dt2.Rows.Add(newRow);
            }
			DataTable dt3 = new DataTable("Three");
			dt3.Columns.Add(new DataColumn("A"));
			dt3.Columns.Add(new DataColumn("B"));
			dt3.Columns.Add(new DataColumn("C"));
			dt3.Columns.Add(new DataColumn("D"));
            for (int i = 0; i <= 8; i++)
            {
                DataRow newRow = dt3.NewRow();
                newRow["A"] = "Test example #p";
                newRow["B"] = "Test";
                newRow["C"] = "Test example #p";
                newRow["D"] = "Test";
                dt3.Rows.Add(newRow);
            }
			DataTable dt4 = new DataTable("Four");
			dt4.Columns.Add(new DataColumn("A"));
			dt4.Columns.Add(new DataColumn("B"));
			dt4.Columns.Add(new DataColumn("C"));
			dt4.Columns.Add(new DataColumn("D"));
            for (int i = 0; i <= 8; i++)
            {
                DataRow newRow = dt4.NewRow();
                newRow["A"] = "Test example #p";
                newRow["B"] = "Test";
                newRow["C"] = "Test example #p";
                newRow["D"] = "Test";
                dt4.Rows.Add(newRow);
            }

			DataSet ds = new DataSet();
			ds.Tables.AddRange(new DataTable[]{dt1, dt2, dt3, dt4});

			this.gridGroupingControl1.DataSource = ds;
            InitializeGrid();


		}


        private void OnQueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
        {
            GridGroupingControl actControl = sender as GridGroupingControl;
            GridTableCellStyleInfo style = (GridTableCellStyleInfo)e.Style;
            if (style.TableCellIdentity.TableCellType == GridTableCellType.RecordFieldCell
                || style.TableCellIdentity.TableCellType == GridTableCellType.AlternateRecordFieldCell)
            {
                //&& (e.TableCellIdentity.TableCellType != GridTableCellType.AddNewRecordFieldCell)
                GridColumnDescriptor column = style.TableCellIdentity.Column;
                if (column.TableDescriptor.Columns.IndexOf(column) == 0)
                {
                    GridRecordRow rec = e.TableCellIdentity.Table.DisplayElements[e.TableCellIdentity.RowIndex] as GridRecordRow;
                    if (rec != null)
                    {
                        DataRowView dr = rec.GetData() as DataRowView;

                        e.Style.ImageIndex = 0;
                    }
                }
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            gridGroupingControl1.BeginUpdate();
            gridGroupingControl1.ResetTableDescriptor();

            DataSet ds = gridGroupingControl1.DataSource as DataSet;
            DataTable test = ds.Tables[0];
            test.Columns.Add("ID");

            gridGroupingControl1.EndUpdate(true);
            gridGroupingControl1.Reinitialize();
        }
	
	}
}
